// Liest eine Datei mit Plot-Koordinaten (LINE Format)
// und korrigiert diese um Meldung "...IEEE_DENORM..."  und
// Schwierigkeiten in gnuplot zu vermeiden
// Gibt korrigierte Koordinaten auf stdout aus

// E.Huckert 02-2022 V1.1

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// --------------------------------------------
void usage()
{
  fprintf(stderr, "Aufruf: correctFloat inpFile >outfile\n");
  fprintf(stderr, "E.Huckert 02-2022\n");
}

// --------------------------------------------
int main(int argc, char *argv[])
{
  FILE *ifd = NULL;
  unsigned count = 0;
  char buf[256];
  float f1, f2;

  usage();
  ifd = fopen(argv[1], "r");
  if (ifd == NULL)
  {
    fprintf(stderr, "FEHLER input file\n");
    goto zurueck;
  }

  while (1)
  {
    if (fgets(buf, sizeof(buf) - 1, ifd) == NULL)
      break;
    if (buf[0] < ' ')
    {
       // Leerzeile
       printf("\n");
       continue;
    }
    // Keine Leerzeile, 2 Koordinaten als float-values
    //printf("buf=%s", buf);
    sscanf(buf, "%f %f", &f1, &f2);
    if (fabs(f1) < 0.0001) f1 = 0.0;
    if (fabs(f2) < 0.0001) f2 = 0.0;
    if (fabs(f1) > 10000.0) f1 = 0.0;
    if (fabs(f2) > 10000.0) f2 = 0.0;
    printf("%f %f\n", f1, f2);
  }   // end while (1)
  //
  zurueck:
  if (ifd != NULL)
    fclose(ifd);
  return 1;
}   // end main()
